;;; -*- Syntax: common-lisp; Mode: LISP; Package: (parser :use common-lisp parser-util); Base: 10 -*- 


;; Sample lexicon
;;

(in-package 'parser :use '(parser-util lisp))

;; NOUNS
;; Names

(put 'john 'noun '(john name))
(put 'mary 'noun '(mary name))
(put 'sue 'noun '(sue name))
(put 'dave 'noun '(dave name))
(put 'bill 'noun '(bill name))

;; singular nouns
(put 'cat 'noun '(cat sin))
(put 'wolf 'noun '(wolf sin))
(put 'fox 'noun '(fox sin))
(put 'bird 'noun '(bird sin))
(put 'caterpillar 'noun '(caterpillar sin))
(put 'snail 'noun '(snail 'sin))
(put 'animal 'noun '(animal 'sin))
(put 'grain 'noun '(grain 'sin))
(put 'plant 'noun '(plant sin))
(put 'food 'noun '(food sin))
(put 'room 'noun '(room sin))
(put 'man 'noun '(man sin))
(put 'mouse 'noun '(mouse sin))
(put 'kitchen 'noun '(kitchen sin))
(put 'ski 'noun '(ski sin))
(put 'class 'noun '(class sin))
(put 'ice-cream 'noun '(ice-cream sin))
(put 'average 'noun '(average sin))
(put 'ksqmile 'noun '(ksqmile sin))
(put 'region 'noun '(region sin))
(put 'sea 'noun '(sea sin))


;; plural nouns
(put 'they 'noun '(they plu)) ;; check
(put 'cats 'noun '(cats plu))
(put 'wolves 'noun '(wolves plu))
(put 'foxes 'noun '(foxes plu))
(put 'birds 'noun '(birds plu))
(put 'caterpillars 'noun '(caterpillars plu))
(put 'snails 'noun '(snails 'plu))
(put 'animals 'noun '(animals 'plu))
(put 'grains 'noun '(grains 'plu))
(put 'plants 'noun '(plants plu))
(put 'food 'noun '(food plu))
(put 'we 'noun '(we plu)) ;; check
(put 'rooms 'noun '(rooms plu)) 
(put 'men 'noun '(men plu))  
(put 'mice 'noun '(mice plu))
(put 'kitchens 'noun '(kitchens plu))
(put 'skies 'noun '(skis plu))  
(put 'classes 'noun '(classes plu))
(put 'ice-cream 'noun '(ice-cream plu)) 
(put 'averages 'noun '(averages plu)) 
(put 'ksqmiles 'noun '(ksqmiles plu)) 
(put 'regions 'noun '(regions plu))
(put 'seas 'noun '(seas plu))




;; Special Adjectives
(put 'less 'adv 'comp-adv)
(put 'more 'adv 'comp-adv)
(put 'much 'adv 'comp-adv)
(put 'least 'adv 'sup-adv)
(put 'most 'adv 'sup-adv)


;; Adverbs
(put 'clearly 'adverb '(clearly adv))
(put 'shortly 'adverb '(shortly adv))



;; VERBS
(put 'exist 'verb '(exist (pres fin) (_ _) (main trans)))
(put 'eat 'verb '(eat (pres fin) (_ _) (main trans)))
(put 'love 'verb '(love (pres fin) (_ _) (main trans)))
(put 'swim 'verb '(swim (pres fin) (_ _) (main trans)))
(put 'like 'verb '(like (pres fin) (_ _) (main trans)))
(put 'squeak 'verb '(squeak (pres fin) (_ _) (main intrans)))
(put 'work 'verb '(work (pres fin) (_ _) (main trans)))
(put 'enojy 'verb '(enjoy (pres fin) (_ _) (main trans)))

(put 'exists 'verb '(exist (pres fin) (3 sin) (main trans)))
(put 'eats 'verb '(eat (pres fin) (3 sin) (main trans)))
(put 'loves 'verb '(love (pres fin) (3 sin) (main trans)))
(put 'swims 'verb '(swim (pres fin) (3 sin) (main trans)))
(put 'likes 'verb '(like (pres fin) (3 sin) (main trans)))
(put 'squeaks 'verb '(squeak (pres fin) (3 sin) (main intrans)))
(put 'works 'verb '(work (pres fin) (3 sin) (main trans)))
(put 'enojys 'verb '(enjoy (pres fin) (3 sin) (main trans)))

(put 'eaten 'verb '(eat (past part) (3 sin) (_ trans)))



(put 'enjoy 'verb '(enjoy (pres fin) (1 plu) (main trans)))
(put 'work 'verb '(work (pres fin) (1 plu) (main trans)))
(put 'swim 'verb '(swim (pres fin) (1 plu) (main trans)))
(put 'eat 'verb '(eat (pres fin) (1 plu) (main trans)))

(put 'existed 'verb '(exist (past _) (_ _) (main trans)))
(put 'chased 'verb '(chase (past _) (_ _) (main trans)))
(put 'worked 'verb '(work (past _) (_ _) (_ trans)))
(put 'located 'verb '(locate (past _) (_ _) (main trans)))
(put 'died 'verb '(die (past _) (_ _) (main intrans)))

(put 'ate 'verb '(eat (past fin) (_ _) (main trans)))
(put 'loved 'verb '(love (past _) (_ _) (_ trans)))
(put 'swam 'verb '(swim (past _) (_ _) (main trans)))
(put 'liked 'verb '(like (past _) (_ _) (_ trans)))
(put 'squeaked 'verb '(squeak (past _) (_ _) (main intrans)))
(put 'enojyed 'verb '(enjoy (past _) (_ _) (_ trans)))
(put 'died 'verb '(die (past _) (_ _) (_ intrans)))

(put 'eating 'verb '(eat (_ part cont) (_ _) (main trans)))
(put 'loving 'verb '(love (_ part cont) (_ _) (_ trans)))
(put 'swiming 'verb '(swim (_ part cont) (_ _) (main trans)))
(put 'liking 'verb '(like (_ part cont) (_ _) (_ trans)))
(put 'squeaking 'verb '(squeak (_ part cont) (_ _) (main intrans)))
(put 'enojying 'verb '(enjoy (_ part cont) (_ _) (_ trans)))

(put 'be 'verb '(be (pres inf) (_ _) (aux be)))
(put 'am 'verb '(be (pres fin) (1 sin) (aux be)))
(put 'are 'verb '(be (pres fin) (2 sin) (aux be)))
(put 'is 'verb '(be (pres fin) (3 sin) (aux be)))
(put 'are 'verb '(be (pres fin) (_ plu) (aux be)))
(put 'was 'verb '(be (past fin) (1 sin) (aux be)))
(put 'were 'verb '(be (past fin) (2 sin) (aux be)))
(put 'was 'verb '(be (past fin) (3 sin) (aux be)))
(put 'been 'verb '(be (past part) (_ _) (aux be)))
(put 'being 'verb '(be (pres part cont) (_ _) (aux be)))

(put 'will 'verb '(will (future _) (_ _) (aux will)))
(put 'would 'verb '(will (past _) (_ _) (aux will)))
(put 'can 'verb '(can (future _) (_ _) (aux can)))
(put 'could 'verb '(can (past _) (_ _) (aux can)))


(put 'have 'verb '(have (pres fin) (1 sin) (aux have)))
(put 'have 'verb '(have (pres fin) (2 sin) (aux have)))
(put 'has 'verb '(have (pres fin) (3 sin) (aux have)))
(put 'have 'verb '(have (pres fin) (_ plu) (aux have)))
(put 'had 'verb '(have (past _) (_ _) (aux have)))
(put 'having 'verb '(have (pres part cont) (_ _) (aux have)))

(put 'do 'verb '(do (pres _) (_ _) (aux ditrans)))
(put 'does 'verb '(do (pres _) (3 sin) (aux ditrans)))
(put 'did 'verb '(do (past _) (_ _) (aux ditrans)))
(put 'doing 'verb '(do (pres part cont) (_ _) (aux ditrans)))
(put 'done 'verb '(do (past part) (_ _) (aux ditrans)))


(put 'border 'verb '(border (_ _) (_ _) (main trans)))
(put 'borders 'verb '(border (pres fin) (3 sin) (main trans)))
(put 'bordered 'verb '(border (past fin) (_ _) (main trans)))
(put 'bordering 'verb '(border (pres part cont) (_ _) (main trans)))

(put 'exceed 'verb '(exceed (_ _) (_ _) (main trans)))
(put 'exceeds 'verb '(exceed (pres fin) (3 sin) (main trans)))
(put 'exceeded 'verb '(exceed (past fin) (_ _) (main trans)))
(put 'exceeding 'verb '(exceed (pres part cont) (_ _) (main trans)))


(put 'flow 'verb '(flow (_ _) (_ _) (main intrans)))
(put 'flows 'verb '(flow (pres fin) (3 sin) (main intrans)))
(put 'flowed 'verb '(flow (past fin) (_ _) (main intrans)))
(put 'flowing 'verb '(flow (pres part cont) (_ _) (main intrans)))

 


;; PREPOPSITIONS
(put 'of 'synt-cat 'prep)
(put 'in 'synt-cat 'prep)
(put 'on 'synt-cat 'prep)
(put 'by 'synt-cat 'prep)
(put 'with 'synt-cat 'prep)
(put 'into 'synt-cat 'prep)
(put 'through 'synt-cat 'prep)
(put 'to 'synt-cat 'prep)

;;; PERSONEL PRONOUNS
;;; nominative case
(put 'i 'pers-pron '((pers-pron i) _ (1 sin) _))
(put 'you 'pers-pron '((pers-pron you) _ (2 _) _)) 
(put 'he 'pers-pron '((pers-pron he) masc (3 sin) _)) 
(put 'she 'pers-pron '((pers-pron she) femm (3 sin) _))
(put 'it 'pers-pron  '((pers-pron it) _ (3 sin) _))
(put 'we 'pers-pron  '((pers-pron we) _ (1 plu) _))
(put 'they 'pers-pron '((pers-pron they) _ (3 plu) _))

;;; objective case
(put 'me 'pers-pron '((pers-pron me) _ (1 sin) obj))
(put 'him 'pers-pron '((pers-pron him) masc (3 sin) obj)) 
(put 'her 'pers-pron '((pers-pron her) femm (3 sin) obj))
(put 'us 'pers-pron  '((pers-pron we) _ (1 plu) obj))
(put 'them 'pers-pron '((pers-pron they) _ (3 plu) obj))


;;; POSSESSIVE PRONOUNS
(put 'my 'poss-pron '((pers-pron my) _ (_ _)))
(put 'mine 'poss-pron '((pers-pron mine) _ (_ _)))
(put 'your 'poss-pron '((pers-pron your) _ (_ _)))
(put 'yours 'poss-pron '((pers-pron yours) _ (_ _)))
(put 'his 'poss-pron '((pers-pron his) masc (_ _)))
(put 'her 'poss-pron '((pers-pron her) femm (_ _)))
(put 'hers 'poss-pron '((pers-pron hers) femm (_ _)))
(put 'its 'poss-pron '((pers-pron its) _ (_ _)))
(put 'our 'poss-pron '((pers-pron our) _ (_ _)))
(put 'ours 'poss-pron '((pers-pron ours) _ (_ _)))
(put 'their 'poss-pron '((pers-pron their) _ (_ _)))
(put 'theirs 'poss-pron '((pers-pron theirs) _ (_ _)))


;; PRONOUNS
(put 'myself 'comp-pers-pron '((comp-pers-pron myself) _ (1 sin) obj))
(put 'yourself 'comp-pers-pron '((comp-pers-pron yourself) _ (2 sin) obj))
(put 'himself 'comp-pers-pron '((comp-pers-pron himself) masc (3 sin) obj))
(put 'herself 'comp-pers-pron '((comp-pers-pron herself) femm (3 sin) obj))
(put 'itself 'comp-pers-pron '((comp-pers-pron itself) _ (3 sin) obj))
(put 'ourselves 'comp-pers-pron '((comp-pers-pron ourselves) _ (1 plu) obj))
(put 'yourselves 'comp-pers-pron '((comp-pers-pron yourselves) _ (2 plu) obj))
(put 'themselves 'comp-pers-pron '((comp-pers-pron themselves) _ (3 plu) obj))



;; RELATIVE PRONOUNS
(put 'that 'synt-cat 'rel-pron)
(put 'which 'synt-cat 'rel-pron)
(put 'who 'synt-cat 'rel-pron)
(put 'what 'synt-cat 'rel-pron)
;; add whoever, whom, etc.. p 18- the elements of grammar

;; General dictionary

;; CONJUNCTIONS
(put 'and 'synt-cat 'conj)
(put 'or 'synt-cat 'conj)

;; Interrogative pronouns
(put 'what 'undef 'int-pron)
(put 'whose 'undef 'int-pron)
(put 'which 'undef 'int-pron)
(put 'who 'subj 'int-pron)
(put 'whom 'compl 'int-pron)

;; Interrogative article
(put 'what 'ques 'int-art)
(put 'which 'ques  'int-art)


;; DETERMINERS
(put 'the 'det '(_ def))   ;; _ is NO??  is it?!
(put 'a 'det '(sin indef))
(put 'an 'det '(sin indef))
(put 'every 'det '(sin indef))
(put 'some 'det '(_ indef))
(put 'any 'det '(_ indef))
(put 'all 'det '(plu indef))
(put 'such 'det '(_ indef))  ;; check..
(put 'each 'det '(sin indef))
(put 'no 'det '(_ indef))

;; QUANTIFIER PRONOUNS 
;; Also known as Indefinite Pronouns (p-20)
(put 'everybody 'quantifier-pron 'every-person)
(put 'everyday 'quantifier-pron 'every-time)
(put 'everything 'quantifier-pron 'every-object)
(put 'everytime 'quantifier-pron 'every-time)


;; PREPOSITIONS
(put 'of 'prep 'prep)
(put 'in 'prep 'prep)
(put 'on 'prep 'prep)
(put 'by 'prep 'prep)
(put 'with 'prep 'prep)
(put 'into 'prep 'prep)
(put 'through 'prep 'prep)
(put 'to 'prep 'prep)



;; Specialized Dictionary
(put 'average 'adj 'restr)
(put 'african 'adj 'restr)
(put 'fat 'adj 'char)
(put 'nice 'adj 'char)
(put 'good 'adj 'char)
(put 'big 'adj 'char)
(put 'bad 'adj 'char)
(put 'small 'adj 'char)
(put 'green 'adj 'char)
(put 'red 'adj 'char)


(put 'large 'rel-adj 'large)

(put 'largest 'sup-adj 'large)
(put 'smallest 'sup-adj 'small)

(put 'smaller 'rel-adj 'small)
(put 'larger 'rel-adj 'large)
(put 'much 'adverb '(much adv))
(put 'very 'adverb '(very adv)) 
